#define NETWORK_HEADERS
#include<NetBuffer.h>
#include<NetEndpoint.h>
#include<NetAddress.h>
#include<sys/socket.h>
#include<arpa/inet.h>
#include<netinet/in.h>
#include<ByteOrder.h>
#include<stdio.h>
#include<stdlib.h>
#include<iostream>
#include<string.h>
using namespace std;

//Prototype class to represent a http header

class haikuhttp{
	
	public:
		BNetBuffer		*buffer;
		const void		*CRLF;
					haikuhttp();
					haikuhttp(haikuhttp &header);
		 bool		addValue(const char *key ,const char* value);
		 string		getallValues();
			void	removeAllValues(string key);
			void	removeValue(string key);
			void	setContentLength(int len);
			void	setContentType(string type);
			bool	hasContentLength();
			bool	hasKey(string key);
			void	setValue(const char* key , const char* value);
	const	char*	value(string key);
			void	tostring() const;
			bool	isValidHeader(const char* header) const;

};

//Construct an empty http header for latter additions to the buffer
haikuhttp::haikuhttp(){
		 buffer = new BNetBuffer(1024);
		 CRLF="\r\n";
}

bool	
haikuhttp::isValidHeader(const char *header) const{
//TODO
//a C++ interators use would be more efficient
const string valid_headers[]={"Accept","Accept-Charset","Accept-Encoding","Accept-Language",
	"Authorization","Expect","From","Host","If-Match,If-Modified-Since",
	"If-None-Match","If-Range","If-Unmodified-Since","Max-Forwards","Proxy-Authorization",
	"Range","Referer","TE","Keep-Alive","User-Agent"};
		int i;
		for ( i =0 ; i<20; i++) {
 			if (strcmp(valid_headers[i].c_str(),header)==0)
				return true;
 }
return false;
}

/*
Set values for the valid keys and add to header buffer area
Add values to the buffer aread
*/
bool
haikuhttp::addValue(const char* header , const char* value){
	if ( isValidHeader(header)){
		 buffer->AppendData((const void *)header , strlen(header));
		 buffer->AppendData((const void *)":",1);
		 buffer->AppendData((const void *)value , strlen(value));
//Every header should terminate in CRLF 
		 buffer->AppendData(CRLF , 2);
		 return true;
		}
cout<<"Invalid headers";
return false;
}
/*
If he content length feild is found in the buffer
returns true
*/
bool
haikuhttp::hasContentLength(){
	if (strstr("Content-Length",(const char *)buffer->Data())==NULL)
		return false;
	else
		return true;
}

/*
Returns true if a particular key is found in the header
*/
bool
haikuhttp::hasKey(string key){
	 if (strstr(key.c_str(),(const char *)buffer->Data())!=NULL)
		return true;
	 else
		return false;
}

/*
Returns the first value for the entry with the given key
If no entry has this key, and empty string is returned.
*/
const char*
haikuhttp::value(string key){
	char *ptr,*str,*tempstart;	
	int start , end , len;
	ptr = strstr((const char *)buffer->Data(),key.c_str());
	str=(char*)malloc(10);
	while (*ptr==' ')
		ptr++;
	while (*ptr!=':')
	//Reach the : first
		 ptr++;
		 ptr++;
	while (*ptr==' ')
		ptr++;
	while (*ptr!=','&&*ptr!='\r'){
		cout<<*ptr;
		*str=*ptr ;
		 ptr++;
		str++;
		}
		str='\0';
 return str;
}
/*
Prints the header
*/
//TODO
//Should return a string

void
haikuhttp::tostring() const{
	 cout<<"Buffer Info";
	 printf("%s",buffer->Data());
}


/*Test main to test the buffer contents
This is the test main which can be used to 
test the class.
*/
/*
int
main()
{
	haikuhttp httpobj;
	cout<<"object creation success";
	httpobj.addValue("Accept-Language","en-us,en");
	httpobj.addValue("Accept-Encoding","gzip,deflate");
	httpobj.addValue("Keep-Alive","300");

	cout<<"\nValue output\n";
	httpobj.value("Accept-Encoding");
	cout<<"AcceptLange: ";
	cout<<httpobj.value("Accept-Language");
	 cout<<"\n";
	cout<<"\n----------------\n";
	cout<<"header information";
	httpobj.tostring();
	 return 0;
}*/

